%define ocamlname nocrypto

Name:           ocaml-%{ocamlname}
Version:        0.5.4
Release:        1%{?dist}.emp1
Summary:        Simpler crypto
License:        ISC
URL:            https://github.com/mirleft/ocaml-nocrypto
Source0:        %{ocamlname}-%{version}.tbz

Requires:  	ocaml >= 4.02.0
Requires:	ocaml-cstruct >= 2.4.0
Requires:	ocaml-cstruct-lwt
Requires:	ocaml-zarith
Requires:	ocaml-lwt
Requires:	ocaml-sexplib < 0.11.0

BuildRequires:  ocaml >= 4.02.0
BuildRequires:  opam-installer >= 2.0
BuildRequires:  ocaml-findlib
BuildRequires:  ocaml-ocamlbuild
BuildRequires:  ocaml-topkg-devel >= 0.9.0
BuildRequires:	ocaml-cstruct-devel >= 2.4.0
BuildRequires:	ocaml-cstruct-lwt-devel
BuildRequires:	ocaml-zarith-devel
BuildRequires:	ocaml-lwt-devel
BuildRequires:	ocaml-sexplib-devel < 0.11.0
BuildRequires:	ocaml-cpuid-devel
BuildRequires:	ocaml-ocb-stubblr
BuildRequires:	ocaml-ppx_deriving
BuildRequires:	ocaml-ppx_sexp_conv < 0.11.0
BuildRequires:	ocaml-ounit

Conflicts:	ocaml-topkg < 0.9.1
Conflicts:	ocaml-ocb-stubbler < 0.1.0
Conflicts:	ocaml-sexplib = 0.9.0

# native is present in this package but detected as requirement
%global __requires_exclude ^ocaml.Native.+

%description
nocrypto is a small cryptographic library that puts emphasis on the applicative
style and ease of use. It includes basic ciphers (AES, 3DES, RC4), hashes (MD5,
SHA1, SHA2), public-key primitives (RSA, DSA, DH) and a strong RNG (Fortuna).

RSA timing attacks are countered by blinding. AES timing attacks are avoided by
delegating to AES-NI.


%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:	ocaml-cstruct-devel >= 2.4.0
Requires:	ocaml-cstruct-lwt-devel
Requires:	ocaml-zarith-devel
Requires:	ocaml-lwt-devel
Requires:	ocaml-sexplib-devel < 0.11.0

%description    devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.

%prep
%setup -q -n %{ocamlname}-%{version}

%build
# dirty hack cause pkg.ml calls opam
export OPAMROOT=%{buildroot}/opam-root
opam init -y

ocaml pkg/pkg.ml build \
      --tests false \
      --with-lwt true \
      --xen false \
      --freestanding false

rm -rf %{buildroot}/opam-root

%install
opam-installer \
	--prefix=%{buildroot}/%{_libdir}/ocaml \
	--libdir=%{buildroot}/%{_libdir}/ocaml \
	%{ocamlname}.install
echo %{ocamlname} > \
    %{buildroot}/%{_libdir}/ocaml/stublibs/dll%{ocamlname}_stubs.so.owner

%files
%doc %{_libdir}/ocaml/doc/%{ocamlname}/LICENSE.md
%{_libdir}/ocaml/%{ocamlname}
%ifarch %{ocaml_native_compiler}
%exclude %{_libdir}/ocaml/%{ocamlname}/*.a
%exclude %{_libdir}/ocaml/%{ocamlname}/*.cmxa
%exclude %{_libdir}/ocaml/%{ocamlname}/*.cmx
%endif
%exclude %{_libdir}/ocaml/%{ocamlname}/*.mli
%{_libdir}/ocaml/stublibs/*.so
%{_libdir}/ocaml/stublibs/*.so.owner

%files devel
%doc %{_libdir}/ocaml/doc/%{ocamlname}/CHANGES.md
%doc %{_libdir}/ocaml/doc/%{ocamlname}/README.md
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/%{ocamlname}/*.a
%{_libdir}/ocaml/%{ocamlname}/*.cmxa
%{_libdir}/ocaml/%{ocamlname}/*.cmx
%endif
%{_libdir}/ocaml/%{ocamlname}/*.mli
